<table [formGroup]="parentFormGroup" class="table" cellspacing="0">
  <tr class="table-header">
    <th></th>
    <th>
      Starting
    </th>
    <th>
      Upper
    </th>
    <th>
      Lower
    </th>
  </tr>
  <tr *ngFor="let mineralData of minerals" [formGroupName]="mineralData.name" class="table-row">
    <td>
      <div class="title">
        {{ mineralData.name }}
      </div>
    </td>
    <td>
      <mat-form-field class="field">
        <input matInput formControlName="starting" type="number" [errorStateMatcher]="errorMatcher[mineralData.name]" />
        <mat-error *ngIf="parentFormGroup.get(mineralData.name).hasError('starting')">
          Starting density should be less than upper density and greater than lower
        </mat-error>
        <mat-error
          *ngIf="
            !parentFormGroup.get(mineralData.name).hasError('starting') &&
            parentFormGroup
              .get(mineralData.name)
              .get('starting')
              .hasError('min')
          "
        >
          Starting density should be a positive number
        </mat-error>
        <mat-error
          *ngIf="
            parentFormGroup
              .get(mineralData.name)
              .get('starting')
              .hasError('required')
          "
        >
          Required
        </mat-error>
      </mat-form-field>
    </td>
    <td>
      <mat-form-field class="field">
        <input matInput formControlName="upper" type="number" [errorStateMatcher]="errorMatcher[mineralData.name]" />
        <mat-error *ngIf="parentFormGroup.get(mineralData.name).hasError('upper')">
          Upper density must be greater than lower density</mat-error
        >
        <mat-error
          *ngIf="
            !parentFormGroup.get(mineralData.name).hasError('upper') &&
            parentFormGroup
              .get(mineralData.name)
              .get('upper')
              .hasError('min')
          "
        >
          Upper density must be a positive number
        </mat-error>
        <mat-error
          *ngIf="
            parentFormGroup
              .get(mineralData.name)
              .get('upper')
              .hasError('required')
          "
        >
          Required
        </mat-error>
      </mat-form-field>
    </td>
    <td>
      <mat-form-field class="field">
        <input matInput formControlName="lower" type="number" [errorStateMatcher]="errorMatcher[mineralData.name]" />
        <mat-error *ngIf="parentFormGroup.get(mineralData.name).hasError('lower')">
          Lower density must be less than upper density
        </mat-error>
        <mat-error
          *ngIf="
            !parentFormGroup.get(mineralData.name).hasError('lower') &&
            parentFormGroup
              .get(mineralData.name)
              .get('lower')
              .hasError('min')
          "
        >
          Lower density must be a positive number
        </mat-error>
        <mat-error
          *ngIf="
            parentFormGroup
              .get(mineralData.name)
              .get('lower')
              .hasError('required')
          "
        >
          Required
        </mat-error>
      </mat-form-field>
    </td>
  </tr>
</table>
